/*
 * Copyright (c) 2000 Frank van Viegen.
 * This code is subject to the GPL. Read COPYING for details.
 */
 
#ifndef CONFIGPARSE_H
#define CONFIGPARSE_H
 
#include "irman.h"

#define CMD_SENDFIFO 1
#define CMD_ACTIVATE 2
#define CMD_COMMAND 3
#define CMD_EXIT 4
#define CMD_WRITEFIFO 5

struct mapstr {
    char *name;
    int expire;
    int terminate;
    struct keystr *key;
    struct mapstr *next;
};

struct keystr {
    char *codename;			/* use NULL for '*' */
    int direct;
    struct keyactionstr *action;
    struct keystr *next;
};

struct keyactionstr {
    int cmdtype;
    char *op1;
    char *op2;
    struct keyactionstr *next;
};

struct codestr {
    char *name;
    ircode code;
    struct codestr *next;
};

struct fifostr {
    char *name;
    char *filename;
    int file;
    int slavefile;
    int type;
    struct fifostr *next;
};


extern struct mapstr *firstMap;
extern struct mapstr *defaultMap;
extern struct mapstr *globalMap;
extern struct fifostr *firstFifo;
extern struct codestr *firstCode;
extern struct keyactionstr *initActionblock;


void addKey(struct mapstr *m, struct keystr *k);
void setDefaultMapName(char *n);
struct mapstr *newMapstr();
struct keystr *newKeystr();
void addKeyaction(struct keystr *k, int cmdtype, char *op1, char *op2);
void newFifo(char *name, char *filename, int type);
void newSignal(char *name, ircode *code);
void initConfigParse();
void setSerial(char *s);
void finishConfigParse();


#endif
