/*
 * (c)1999-2000 Frank van Viegen
 * This code is subject to the GPL. Read COPYING for details.
 */

#ifdef WITH_DMALLOC
  #include <dmalloc.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#define IOSEL_IRMAN 1
#define IOSEL_CODEHANDLE 2
#define IOSEL_MAPEXPIRE 3
#define IOSEL_KEYUNBLOCK 4
#define IOSEL_KEYBOARD 5

extern FILE *outfd;
extern FILE *logfd;

char *logtime();

/* Time in logging is disabled
#define loginfo(x,i...)							\
{									\
	if (logfd) {							\
		fprintf(logfd,"%s" x ,logtime() ,##i);			\
		fflush(logfd);						\
	}								\
}
*/
/* The gcc pre-processor seems to need the empty space after 'logtime()',
 * since if 'logtime()' is attached to the ',##i' term, the 'logtime()'
 * term is removed in the pre-processed output when 'i' represents no
 * parameters. Is this a gcc bug or ansi?
 */
 

#define loginfo(x,i...)							\
{									\
	if (logfd) {							\
		fprintf(logfd, x, ##i);					\
		fflush(logfd);						\
	}								\
}


#define printinfo(i...) { if (outfd) { fprintf(outfd,##i); fflush(outfd); } }

#define fatalerror(e,i...)								\
{											\
	loginfo("Fatal error: " e ".\n", ##i);						\
	if (outfd && logfd!=stdout) fprintf(outfd,"Fatal error: " e ".\n" "", ##i);	\
	exit(1);									\
}

#define warning(e,i...)									\
{											\
	if (logfd) { fprintf(logfd,"Warning: " e ".\n" "", ##i); fflush(logfd); }	\
	if (outfd && logfd!=stdout) { fprintf(outfd,"Warning: " e ".\n" "", ##i); fflush(outfd);	}	\
}

/* The extra (seemesly useless) pair of quotes "" work around what appears to
 * be a(nother) bug in the gcc precompiler.
 */
 