#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <fcntl.h>

int main(int argc, char *argv[])
{
	int i;
	int *fds;
	int maxfds, mfd=0;
	fd_set fdset;
	char c;
	
	fds = (int *)malloc(argc*sizeof(int));
	fds[0] = 0;
	maxfds = argc-1;
	
	for (i=1;i<argc;i++) {
		if (!(fds[i]=open(argv[i], O_RDONLY))) {
			fprintf(stderr,"Cannot open '%s'.\n",argv[i]);
			exit(1);
		}
		if (fds[i]>mfd) mfd = fds[i];
	}

	while(1) {
		FD_ZERO(&fdset);
		for (i=0;i<=maxfds;i++) FD_SET(fds[i],&fdset);
		if ((i=select(mfd+1, &fdset, NULL, NULL, NULL))<0) return 1;
		for (i=0;i<=maxfds;i++) {
			if (FD_ISSET(fds[i],&fdset)) {
				if (!read(fds[i], &c, 1)) {
					fds[i]=fds[maxfds];
					maxfds--;
					if (maxfds<0) return 0;
				}
				write(1, &c, 1);
			}
		}
	}

	return 0;
}